/*
Copyright (c) 2006-2010 Nokia Corporation and/or its subsidiary(-ies). All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

* Redistributions of source code must retain the above copyright notice, this
 list of conditions and the following disclaimer.
* Redistributions in binary form must reproduce the above copyright notice,
 this list of conditions and the following disclaimer in the documentation
 and/or other materials provided with the distribution.
* Neither the name of Nokia Corporation nor the names of its contributors
 may be used to endorse or promote products derived from this software
 without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

Description:
CentRepExample .h
Contains the CCentRepExample class. 
*/





/**
 @file
*/
#ifndef __CENTREPEXAMPLE_H__
#define __CENTREPEXAMPLE_H__

// Symbian platform includes
#include <centralrepository.h> 

/**
CCentRepExample demonstrates some uses of the CRepository class.
CRepository provides access to the Symbian platform central repository,
which is used to store system and application settings. 

The class demonstrates how to open a repository, read, write,
and delete settings, perform operations in a transaction, 
find settings, restore default settings, and request 
change notifications.
*/
class CCentRepExample :public CBase
	{
public:
	static CCentRepExample* NewLC();

	~CCentRepExample();
	void ResetL();
	void OpenRepositoryL();
	void RdChgSetL();
	void ReadSettingsL();
	void ChangeSettingsL();
	void MoveSettingsL();
	void ResetAndNotifyL();
	void FindSettingsL();
	void TransactionFuncL();
	void DeleteL();
	
private:
	CCentRepExample();
	void ConstructL();
private:
	/** Pointer to the console interface */
	CConsoleBase* 		iConsole;
	/** Pointer to the class that provides access to a repository. */
	CRepository* iRepository;
    };

#endif //__CENTREPEXAMPLE_H__
